#include <X11/Xatom.h>
#include <X11/keysym.h>
#include <X11/Xlib.h>
#include <X11/Xresource.h>
#include <X11/Xutil.h>

#include <iostream>

void print_key(Display *display, int keyc)
{
    bool was_escape = false;

    for (int i = 0; i < 2; ++i)
    {
        int keysym = XKeycodeToKeysym (display, keyc, i);

        int val = keysym & 0xff;
        if ('\\' == val)
        {
            std::cout << "\\\\";
        }
        else if ('"' == val)
        {
            std::cout << "\\\"";
        }
        else if ((val > 32) && (val < 127))
        {
            if (
                   was_escape
                && (
                       ((val >= '0') && (val <= '9'))
                    || ((val >= 'A') && (val <= 'F'))
                    || ((val >= 'a') && (val <= 'f'))
                   )
               )
            {
                std::cout << "\"\"";
            }
            std::cout << (char) val;
        }
        else
        {
            std::cout << "\\x" << std::hex << (int) val << std::dec;
            was_escape = true;
        }
    }
}

int main()
{
    Display *display = XOpenDisplay(NULL);
    std::cout << "\"";
    print_key(display, 49);
    for (int i = 10; i <= 21; ++i)
    {
        std::cout << "\",\"";
        print_key(display, i);
    }
    std::cout << "\"," << std::endl;
    std::cout << "\"";
    print_key(display, 24);
    for (int i = 25; i <= 35; ++i)
    {
        std::cout << "\",\"";
        print_key(display, i);
    }
    std::cout << "\"," << std::endl;
    std::cout << "\"";
    print_key(display, 38);
    for (int i = 39; i <= 48; ++i)
    {
        std::cout << "\",\"";
        print_key(display, i);
    }
    std::cout << "\",\"";
    print_key(display, 51);
    std::cout << "\"," << std::endl;
    std::cout << "\"";
    print_key(display, 52);
    for (int i = 53; i <= 61; ++i)
    {
        std::cout << "\",\"";
        print_key(display, i);
    }
    std::cout << "\",\"";
    print_key(display, 94); /* The 102nd key */
    std::cout << "\",\"";
    print_key(display, 211); /* The Brazilian key */
    std::cout << "\",\"";
    print_key(display, 133); /* The Yen key */
    std::cout << "\"" << std::endl;
    return 0;
}
